## rocr-runtime 5.0.0

=== src/CMakeLists.txt ===
################################################################################
##
## The University of Illinois/NCSA
## Open Source License (NCSA)
##
## Copyright (c) 2014-2021, Advanced Micro Devices, Inc. All rights reserved.
##
## Developed by:
##
##                 AMD Research and AMD HSA Software Development
##
##                 Advanced Micro Devices, Inc.
##
##                 www.amd.com
##
## Permission is hereby granted, free of charge, to any person obtaining a copy
## of this software and associated documentation files (the "Software"), to
## deal with the Software without restriction, including without limitation
## the rights to use, copy, modify, merge, publish, distribute, sublicense,
## and/or sell copies of the Software, and to permit persons to whom the
## Software is furnished to do so, subject to the following conditions:
##
##  - Redistributions of source code must retain the above copyright notice,
##    this list of conditions and the following disclaimers.
##  - Redistributions in binary form must reproduce the above copyright
##    notice, this list of conditions and the following disclaimers in
##    the documentation and/or other materials provided with the distribution.
##  - Neither the names of Advanced Micro Devices, Inc,
##    nor the names of its contributors may be used to endorse or promote
##    products derived from this Software without specific prior written
##    permission.
##
## THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
## IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
## FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
## THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
## OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
## ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
## DEALINGS WITH THE SOFTWARE.
##
################################################################################

cmake_minimum_required ( VERSION 3.7 )

## Clear target dependency data.
## Needed to allow UI transitions between static and dynamic builds.
## Need an update to CMake 3.12 to remove this hack. See CMake policy change CMP0073.
unset ( hsa-runtime64_LIB_DEPENDS CACHE )

## Set core runtime module name and project name.
set ( CORE_RUNTIME_NAME "hsa-runtime64" )
set ( CORE_RUNTIME_TARGET "${CORE_RUNTIME_NAME}" )
set ( CORE_RUNTIME_LIBRARY "lib${CORE_RUNTIME_TARGET}" )

## Set project name
project( ${CORE_RUNTIME_TARGET} )

## Utilty functions
list ( APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake_modules" )
include ( utils )
include ( hsa_common )
include ( GNUInstallDirs )

## Expose static library option
if ( NOT DEFINED BUILD_SHARED_LIBS )
  set ( BUILD_SHARED_LIBS ON )
endif()
set ( BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS} CACHE BOOL "Build shared library (.so) or not.")

## Adjust target name for static builds
## Original name will be an interface target that adds --whole-archive linker options around the target.
if( NOT ${BUILD_SHARED_LIBS} )
  set ( CORE_RUNTIME_TARGET "${CORE_RUNTIME_TARGET}_static" )
endif()

# Optionally, build HSA Runtime with ccache.
set(ROCM_CCACHE_BUILD OFF CACHE BOOL "Set to ON for a ccache enabled build")
if (ROCM_CCACHE_BUILD)
  find_program(CCACHE_PROGRAM ccache)
  if (CCACHE_PROGRAM)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ${CCACHE_PROGRAM})
  else()
    message(WARNING "Unable to find ccache. Falling back to real compiler")
  endif() # if (CCACHE_PROGRAM)
endif() # if (ROCM_CCACHE_BUILD)

## Get version strings
get_version ( "1.5.0" )
if ( ${ROCM_PATCH_VERSION} )
  set ( VERSION_PATCH ${ROCM_PATCH_VERSION})
endif()
set ( SO_VERSION_STRING "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}" )
set ( PACKAGE_VERSION_STRING "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_COMMIT_COUNT}" )

## Find external dependencies.
find_package(LibElf REQUIRED)
find_package(hsakmt 1.0 REQUIRED HINTS ${CMAKE_INSTALL_PREFIX} PATHS /opt/rocm)

## Create the rocr target.
add_library( ${CORE_RUNTIME_TARGET} "" )

## Enforce uniform output file naming.
set_property(TARGET  ${CORE_RUNTIME_TARGET} PROPERTY OUTPUT_NAME ${CORE_RUNTIME_NAME} )

## Compiler preproc definitions.
target_compile_definitions(${CORE_RUNTIME_TARGET} PRIVATE "${HSA_COMMON_DEFS}" __linux__ HSA_EXPORT=1 HSA_EXPORT_FINALIZER=1 HSA_EXPORT_IMAGES=1 HSA_DEPRECATED=
ROCR_BUILD_ID="${PACKAGE_VERSION_STRING}-${VERSION_JOB}-${VERSION_HASH}" )

## Check for memfd_create syscall
include(CheckSymbolExists)
CHECK_SYMBOL_EXISTS ( "__NR_memfd_create" "sys/syscall.h" HAVE_MEMFD_CREATE )
if ( HAVE_MEMFD_CREATE )
  target_compile_definitions(${CORE_RUNTIME_TARGET} PRIVATE HAVE_MEMFD_CREATE )
endif()

## Set include directories for ROCr runtime
target_include_directories( ${CORE_RUNTIME_TARGET}
  PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/inc>
  $<INSTALL_INTERFACE:include/hsa>
  PRIVATE
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/libamdhsacode )

## Set RUNPATH - ../../lib covers use of the legacy symlink in /hsa/lib/
set_property(TARGET ${CORE_RUNTIME_TARGET} PROPERTY INSTALL_RPATH "$ORIGIN;$ORIGIN/../../lib;$ORIGIN/../../lib64;$ORIGIN/../lib64" )

## ------------------------- Linux Compiler and Linker options -------------------------
set ( HSA_CXX_FLAGS ${HSA_COMMON_CXX_FLAGS} -fexceptions -fno-rtti -fvisibility=hidden -Wno-error=missing-braces -Wno-error=sign-compare -Wno-sign-compare -Wno-write-strings -Wno-conversion-null -fno-math-errno -fno-threadsafe-statics -fmerge-all-constants -fms-extensions -Wno-error=comment -Wno-comment -Wno-error=pointer-arith -Wno-pointer-arith -Wno-error=unused-variable -Wno-error=unused-function )

## Extra image settings - audit!
set ( HSA_CXX_FLAGS ${HSA_CXX_FLAGS} -Wno-deprecated-declarations )

if ( CMAKE_COMPILER_IS_GNUCXX )
    set ( HSA_CXX_FLAGS ${HSA_CXX_FLAGS} -Wno-error=maybe-uninitialized -Wno-error=unused-but-set-variable)
endif ()
if ( CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  set ( HSA_CXX_FLAGS ${HSA_CXX_FLAGS} -Wno-error=self-assign)
  if( ${CMAKE_CXX_COMPILER_VERSION} VERSION_GREATER_EQUAL 13)
    set ( HSA_CXX_FLAGS ${HSA_CXX_FLAGS} -Wno-error=unused-but-set-variable)
  endif()
endif()

set ( DRVDEF "${CMAKE_CURRENT_SOURCE_DIR}/hsacore.so.def" )
set ( LNKSCR "hsacore.so.link" )
set ( HSA_SHARED_LINK_FLAGS "-Wl,-Bdynamic -Wl,-z,noexecstack -Wl,${CMAKE_CURRENT_SOURCE_DIR}/${LNKSCR} -Wl,--version-script=${DRVDEF} -Wl,--enable-new-dtags" )

target_compile_options(${CORE_RUNTIME_TARGET} PRIVATE ${HSA_CXX_FLAGS})
#target_link_options not available prior to CMake 3.13
set_property(TARGET ${CORE_RUNTIME_TARGET} PROPERTY LINK_FLAGS ${HSA_SHARED_LINK_FLAGS})
##  -------------------------  End Compiler and Linker options ----------------------------

## Source files.
set ( SRCS core/util/lnx/os_linux.cpp
           core/util/small_heap.cpp
           core/util/timer.cpp
           core/util/flag.cpp
           core/runtime/amd_blit_kernel.cpp
           core/runtime/amd_blit_sdma.cpp
           core/runtime/amd_cpu_agent.cpp
           core/runtime/amd_gpu_agent.cpp
           core/runtime/amd_hsa_loader.cpp
           core/runtime/amd_aql_queue.cpp
           core/runtime/amd_loader_context.cpp
           core/runtime/hsa_ven_amd_loader.cpp
           core/runtime/amd_memory_region.cpp
           core/runtime/amd_filter_device.cpp
           core/runtime/amd_topology.cpp
           core/runtime/default_signal.cpp
           core/runtime/host_queue.cpp
           core/runtime/hsa.cpp
           core/runtime/hsa_api_trace.cpp
           core/runtime/hsa_ext_amd.cpp
           core/runtime/hsa_ext_interface.cpp
           core/runtime/interrupt_signal.cpp
           core/runtime/intercept_queue.cpp
           core/runtime/ipc_signal.cpp
           core/runtime/isa.cpp
           core/runtime/runtime.cpp
           core/runtime/signal.cpp
           core/runtime/queue.cpp
           core/runtime/cache.cpp
           core/common/shared.cpp
           core/common/hsa_table_interface.cpp
           loader/executable.cpp
           libamdhsacode/amd_elf_image.cpp
           libamdhsacode/amd_hsa_code_util.cpp
           libamdhsacode/amd_hsa_locks.cpp
           libamdhsacode/amd_options.cpp
           libamdhsacode/amd_hsa_code.cpp )

target_sources( ${CORE_RUNTIME_TARGET} PRIVATE ${SRCS} )

if ( NOT DEFINED IMAGE_SUPPORT )
  set ( IMAGE_SUPPORT ON )
endif()
set ( IMAGE_SUPPORT ${IMAGE_SUPPORT} CACHE BOOL "Build with image support (default: ON)." )

## Optional image module defintions.
if(${IMAGE_SUPPORT})
  ## Image definitons - audit!
  target_compile_definitions(${CORE_RUNTIME_TARGET} PRIVATE
    HSA_IMAGE_SUPPORT
    UNIX_OS
    LINUX
    __AMD64__
    __x86_64__
    AMD_INTERNAL_BUILD
    BRAHMA_BUILD=1 )

  set ( IMAGE_SRCS image/addrlib/src/addrinterface.cpp
                   image/addrlib/src/core/coord.cpp
                   image/addrlib/src/core/addrlib.cpp
                   image/addrlib/src/core/addrlib1.cpp
                   image/addrlib/src/core/addrlib2.cpp
                   image/addrlib/src/core/addrobject.cpp
                   image/addrlib/src/core/addrelemlib.cpp
                   image/addrlib/src/r800/ciaddrlib.cpp
                   image/addrlib/src/r800/egbaddrlib.cpp
                   image/addrlib/src/r800/siaddrlib.cpp
                   image/addrlib/src/gfx9/gfx9addrlib.cpp
                   image/addrlib/src/gfx10/gfx10addrlib.cpp
                   image/device_info.cpp
                   image/hsa_ext_image.cpp
                   image/image_runtime.cpp
                   image/image_manager.cpp
                   image/image_manager_kv.cpp
                   image/image_manager_ai.cpp
                   image/image_manager_nv.cpp
                   image/image_lut_kv.cpp
                   image/blit_object_gfx7xx.cpp
                   image/blit_object_gfx8xx.cpp
                   image/blit_object_gfx9xx.cpp
                   image/blit_kernel.cpp
                   ${CMAKE_CURRENT_BINARY_DIR}/image/blit_src/opencl_blit_objects.cpp )

  set_source_files_properties(${CMAKE_CURRENT_BINARY_DIR}/image/blit_src/opencl_blit_objects.cpp PROPERTIES GENERATED TRUE)

  target_include_directories( ${CORE_RUNTIME_TARGET}
    PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}/image
    ${CMAKE_CURRENT_SOURCE_DIR}/image/addrlib/
    ${CMAKE_CURRENT_SOURCE_DIR}/image/addrlib/inc
    ${CMAKE_CURRENT_SOURCE_DIR}/image/addrlib/src
    ${CMAKE_CURRENT_SOURCE_DIR}/image/addrlib/src/core
    ${CMAKE_CURRENT_SOURCE_DIR}/image/addrlib/src/r800
    ${CMAKE_CURRENT_SOURCE_DIR}/image/addrlib/src/gfx9
    ${CMAKE_CURRENT_SOURCE_DIR}/image/addrlib/src/gfx10
    ${CMAKE_CURRENT_SOURCE_DIR}/image/addrlib/src/chip/r800
    ${CMAKE_CURRENT_SOURCE_DIR}/image/addrlib/src/chip/gfx9
    ${CMAKE_CURRENT_SOURCE_DIR}/image/addrlib/src/chip/gfx10 )

  target_sources( ${CORE_RUNTIME_TARGET} PRIVATE ${IMAGE_SRCS} )

  ## Depend on blit kernel target.
  add_subdirectory( ${CMAKE_CURRENT_SOURCE_DIR}/image/blit_src )
  add_dependencies( ${CORE_RUNTIME_TARGET} opencl_blit_objects )

endif()

## Link dependencies.
target_link_libraries ( ${CORE_RUNTIME_TARGET} PRIVATE hsakmt::hsakmt )
target_link_libraries ( ${CORE_RUNTIME_TARGET} PRIVATE elf::elf dl pthread rt )

## Set the VERSION and SOVERSION values
set_property ( TARGET ${CORE_RUNTIME_TARGET} PROPERTY VERSION "${SO_VERSION_STRING}" )
set_property ( TARGET ${CORE_RUNTIME_TARGET} PROPERTY SOVERSION "${VERSION_MAJOR}" )

## Add the public interface export target if doing a static build.
## Bind ROCr dependencies to the interface target rather than to the source build
## target so that -Wl,--whole-archive is tightly applied.  Requires binding
## indirectly to the source build taret.
if( NOT ${BUILD_SHARED_LIBS} )
  add_library(${CORE_RUNTIME_NAME} INTERFACE)

  ## Bind to source build target interface but not its link requirements.

=== debian/changelog ===
rocr-runtime (5.0.0-1) unstable; urgency=medium

  [ Maxime Chambonnet ]
  * New upstream version 5.0.0
  * patched cmake to find devlibs
  * Adapted bitcode dir to /usr/lib/triple
  * Update LLVM B-D to version 14
  * Fixed typo in d/control

  [ Mo Zhou ]
  * Add requirement (>= 5.0.0~) for B-D libhsakmt-dev and rocm-device-libs.
  * Don't install the duplicated license file.
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Mon, 14 Feb 2022 16:24:34 -0500

rocr-runtime (4.5.2-1) experimental; urgency=medium

  [ Maxime Chambonnet ]
  * New upstream version 4.5.2
  * Added "Build-Depends-Package" in debian/*.symbols
  * Passed the hardening flag in debian/rules
  * Removed dropped files in debian/copyright
  * Debian standards 4.4.1 --> 4.6.0
  * Added myself to uploaders
  * propagated soname rollback to symbol
  * Remove uupdate from d/watch
  * Explicitly remove temporary cmake building directory for object files.

  [ Mo Zhou ]
  * Add the d/watch file.
  * Add the missing Clang-13 and LLVM-13 build dependencies.
  * Add the missing B-D: xxd and rocm-device-libs.
  * d/rules: [CMake] Specify BITECODE_DIR variable.
  * Add missing B-D on lld-13.
  * Update maintainer address to debian-ai@l.d.o
  * Refresh copyright with cme/manual fix.
  * Apply wrap-and-sort.
  * Upload to experimental.

 -- Mo Zhou <lumin@debian.org>  Thu, 03 Feb 2022 20:01:52 -0500

rocr-runtime (3.5.0-1~exp1) experimental; urgency=medium

  * Initial release. (Closes: #960981)

  [ Mo Zhou ]
  * Initial packaging.

  [ Norbert Preining ]
  * Update to 3.5.0.

 -- Norbert Preining <norbert@preining.info>  Wed, 03 Jun 2020 12:49:06 +0900

=== debian/control ===
Source: rocr-runtime
Section: video
Homepage: https://github.com/RadeonOpenCompute/ROCR-Runtime/
Priority: optional
Standards-Version: 4.6.0
Vcs-Git: https://salsa.debian.org/rocm-team/rocr-runtime.git
Vcs-Browser: https://salsa.debian.org/rocm-team/rocr-runtime
Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>,
           Norbert Preining <norbert@preining.info>,
           Maxime Chambonnet <maxzor@maxzor.eu>
Build-Depends: clang-14,
               cmake,
               debhelper-compat (= 13),
               libclang-14-dev,
               libelf-dev,
               libhsakmt-dev (>= 5.0.0~),
               lld-14,
               llvm-14-dev,
               rocm-device-libs (>= 5.0.0~),
               xxd

Package: libhsa-runtime64-1
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: HSA Runtime API and runtime for ROCm
 This library provides user-mode API interfaces necessary for host applications
 to launch compute kernels to available HSA ROCm kernel agents.

Package: libhsa-runtime-dev
Section: libdevel
Architecture: any
Depends: libhsa-runtime64-1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: HSA Runtime API and runtime for ROCm - development files
 This library provides user-mode API interfaces necessary for host applications
 to launch compute kernels to available HSA ROCm kernel agents.
 .
 This package contains the development headers.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ -Dsrc -Scmake

# execute_before_dh_clean:
# 	-$(RM) -rf obj-$(DEB_HOST_MULTIARCH)

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBITCODE_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)/amdgcn/bitcode
# 		-DHSAKMT_INC_PATH=/usr/include/rocm
#		-DClang_DIR=/usr/lib/llvm13/

## rocr-runtime 5.1.0

=== debian/changelog ===
rocr-runtime (5.1.0-2ubuntu0.1) kinetic; urgency=medium

  * Patch: Fix Segfault in hsa_init on systems with an AMD GPU
    (LP: #2007993).

 -- Cordell Bloor <cgmb@slerp.xyz>  Fri, 21 Apr 2023 14:55:45 -0600

rocr-runtime (5.1.0-2) unstable; urgency=medium

  * Disable IMAGE_SUPPORT for non-amd64 architectures.

 -- Mo Zhou <lumin@debian.org>  Fri, 08 Apr 2022 10:26:29 -0400

rocr-runtime (5.1.0-1) unstable; urgency=medium

  * New upstream version 5.1.0
  * Bump version requirement of ROCm B-D to (>= 5.1.0~).

 -- Mo Zhou <lumin@debian.org>  Thu, 07 Apr 2022 12:42:34 -0400

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,8 @@
 Standards-Version: 4.6.0
 Vcs-Git: https://salsa.debian.org/rocm-team/rocr-runtime.git
 Vcs-Browser: https://salsa.debian.org/rocm-team/rocr-runtime
-Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
 Uploaders: Mo Zhou <lumin@debian.org>,
            Norbert Preining <norbert@preining.info>,
            Maxime Chambonnet <maxzor@maxzor.eu>
@@ -14,10 +15,10 @@
                debhelper-compat (= 13),
                libclang-14-dev,
                libelf-dev,
-               libhsakmt-dev (>= 5.0.0~),
+               libhsakmt-dev (>= 5.1.0~),
                lld-14,
                llvm-14-dev,
-               rocm-device-libs (>= 5.0.0~),
+               rocm-device-libs (>= 5.1.0~),
                xxd
 
 Package: libhsa-runtime64-1

## rocr-runtime 5.2.3

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -59,6 +59,8 @@
 list ( APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake_modules" )
 include ( utils )
 include ( hsa_common )
+# Set default libdir to be "lib" for ROCm, distros will override this anyway:
+set(CMAKE_INSTALL_LIBDIR "lib" CACHE STRING "Library install directory")
 include ( GNUInstallDirs )
 
 ## Expose static library option
@@ -117,7 +119,7 @@
 target_include_directories( ${CORE_RUNTIME_TARGET}
   PUBLIC
   $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/inc>
-  $<INSTALL_INTERFACE:include/hsa>
+  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/hsa>
   PRIVATE
   ${CMAKE_CURRENT_SOURCE_DIR}
   ${CMAKE_CURRENT_SOURCE_DIR}/libamdhsacode )
@@ -191,10 +193,10 @@
 
 target_sources( ${CORE_RUNTIME_TARGET} PRIVATE ${SRCS} )
 
-if ( NOT DEFINED IMAGE_SUPPORT )
+if ( NOT DEFINED IMAGE_SUPPORT AND CMAKE_SYSTEM_PROCESSOR MATCHES "i?86|x86_64|amd64|AMD64" )
   set ( IMAGE_SUPPORT ON )
 endif()
-set ( IMAGE_SUPPORT ${IMAGE_SUPPORT} CACHE BOOL "Build with image support (default: ON)." )
+set ( IMAGE_SUPPORT ${IMAGE_SUPPORT} CACHE BOOL "Build with image support (default: ON for x86, OFF elsewise)." )
 
 ## Optional image module defintions.
 if(${IMAGE_SUPPORT})
@@ -203,8 +205,6 @@
     HSA_IMAGE_SUPPORT
     UNIX_OS
     LINUX
-    __AMD64__
-    __x86_64__
     AMD_INTERNAL_BUILD
     BRAHMA_BUILD=1 )
 
@@ -269,8 +269,3 @@
 ## Add the public interface export target if doing a static build.
 ## Bind ROCr dependencies to the interface target rather than to the source build
 ## target so that -Wl,--whole-archive is tightly applied.  Requires binding
-## indirectly to the source build taret.
-if( NOT ${BUILD_SHARED_LIBS} )
-  add_library(${CORE_RUNTIME_NAME} INTERFACE)
-
-  ## Bind to source build target interface but not its link requirements.

=== src/image/blit_src/CMakeLists.txt ===
################################################################################
##
## The University of Illinois/NCSA
## Open Source License (NCSA)
##
## Copyright (c) 2014-2020, Advanced Micro Devices, Inc. All rights reserved.
##
## Developed by:
##
##                 AMD Research and AMD HSA Software Development
##
##                 Advanced Micro Devices, Inc.
##
##                 www.amd.com
##
## Permission is hereby granted, free of charge, to any person obtaining a copy
## of this software and associated documentation files (the "Software"), to
## deal with the Software without restriction, including without limitation
## the rights to use, copy, modify, merge, publish, distribute, sublicense,
## and/or sell copies of the Software, and to permit persons to whom the
## Software is furnished to do so, subject to the following conditions:
##
##  - Redistributions of source code must retain the above copyright notice,
##    this list of conditions and the following disclaimers.
##  - Redistributions in binary form must reproduce the above copyright
##    notice, this list of conditions and the following disclaimers in
##    the documentation and/or other materials provided with the distribution.
##  - Neither the names of Advanced Micro Devices, Inc,
##    nor the names of its contributors may be used to endorse or promote
##    products derived from this Software without specific prior written
##    permission.
##
## THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
## IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
## FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
## THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
## OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
## ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
## DEALINGS WITH THE SOFTWARE.
##
################################################################################

cmake_minimum_required ( VERSION 3.7 )

# Flag to abort before executing after default initialization of cache variables
set (QUIT 0)

# Import target 'clang'
find_package(Clang REQUIRED HINTS ${CMAKE_INSTALL_PREFIX}/llvm ${CMAKE_PREFIX_PATH}/llvm PATHS /opt/rocm/llvm )

# Device libs doesn't support find_package yet.
set(PREFIX_HINTS "")
foreach(hint "/amdgcn/bitcode" "/lib/bitcode" "/lib/x86_64/bitcode")
  foreach(path ${CMAKE_PREFIX_PATH})
    string(APPEND path ${hint})
    list(APPEND PREFIX_HINTS ${path})
  endforeach(path)
endforeach(hint)

get_include_path(BITCODE_DIR "Bitcode library path" RESULT FOUND NAMES "opencl.bc" "opencl.amdgcn.bc"
  HINTS
    "${CMAKE_INSTALL_PREFIX}/amdgcn/bitcode"
    "${CMAKE_INSTALL_PREFIX}/lib/bitcode"
    "${CMAKE_INSTALL_PREFIX}/lib/x86_64/bitcode"
    "${PREFIX_HINTS}"
  PATHS
    "/opt/rocm/amdgcn/bitcode"
    "/opt/rocm/lib/bitcode"
    "/opt/rocm/lib"
    "/opt/rocm/lib/x86_64/bitcode")
if (NOT ${FOUND})
  set (QUIT 1)
endif()

# Determine the target devices if not specified
if (NOT DEFINED TARGET_DEVICES)
  set (TARGET_DEVICES "gfx700;gfx701;gfx702;gfx801;gfx802;gfx803;gfx805;gfx810;gfx900;gfx902;gfx904;gfx906;gfx908;gfx909;gfx90a;gfx90c;gfx1010;gfx1011;gfx1012;gfx1013;gfx1030;gfx1031;gfx1032;gfx1033;gfx1034;gfx1035")
endif()
set( TARGET_DEVICES ${TARGET_DEVICES} CACHE STRING "Build targets" FORCE )

# End of default configuration and path checking.
# Quit if configuration is incomplete.
if (QUIT)
  message(FATAL_ERROR "Configuration halted.")
  return()
endif()

if(${CMAKE_VERBOSE_MAKEFILE})
  get_property(clang_path TARGET clang PROPERTY LOCATION)
  message("Using clang from: ${clang_path}")
  message("Build Setting:")
  message("  Target Devices*: ${TARGET_DEVICES}")
  message("  (Specify \";\" separated list of target IDs.)")
  message("       Clang path: ${clang_path}")
  message("      Bitcode Dir: ${BITCODE_DIR}")
endif()

##==========================================
##  Add custom command to generate a kernel code object file
##==========================================
function(gen_kernel_bc TARGET_ID INPUT_FILE OUTPUT_FILE)

  string (REGEX MATCH "^gfx([^:]+)" GFXIP "${TARGET_ID}")
  set (GFXIP_NUMBER "${CMAKE_MATCH_1}")
  # Report syntactically invalid target IDs and terminate.
  if (NOT GFXIP)
    message(FATAL_ERROR "Invalid target (${TARGET_ID}) specified for generating BLIT kerenel")
    return()
  endif()
  # Determine if device-libs is following old or new layout
  if(EXISTS "${BITCODE_DIR}/opencl.amdgcn.bc")
    set(BITCODE_ARGS "-nogpulib
      -Xclang -mlink-bitcode-file -Xclang ${BITCODE_DIR}/opencl.amdgcn.bc
      -Xclang -mlink-bitcode-file -Xclang ${BITCODE_DIR}/ockl.amdgcn.bc
      -Xclang -mlink-bitcode-file -Xclang ${BITCODE_DIR}/ocml.amdgcn.bc
      -Xclang -mlink-bitcode-file -Xclang ${BITCODE_DIR}/oclc_daz_opt_on.amdgcn.bc
      -Xclang -mlink-bitcode-file -Xclang ${BITCODE_DIR}/oclc_isa_version_${GFXIP_NUMBER}.amdgcn.bc
      -Xclang -mlink-bitcode-file -Xclang ${BITCODE_DIR}/oclc_unsafe_math_off.amdgcn.bc
      -Xclang -mlink-bitcode-file -Xclang ${BITCODE_DIR}/oclc_finite_only_off.amdgcn.bc")
  else()
    set(BITCODE_ARGS "--hip-device-lib-path=${BITCODE_DIR}")
  endif()

  separate_arguments(CLANG_ARG_LIST UNIX_COMMAND
    "-O2 -x cl -cl-denorms-are-zero -cl-std=CL2.0 -target amdgcn-amd-amdhsa
    -Xclang -finclude-default-header -mcpu=${TARGET_ID}
    ${BITCODE_ARGS} -o ${OUTPUT_FILE} ${INPUT_FILE}")

  ## Add custom command to produce a code object file.
  ## This depends on the kernel source file & compiler.
  ## It does not pickup devicelib changes.  It is not clear
  ## how to do that after conversion to --rocm-path is done.
  add_custom_command(OUTPUT ${OUTPUT_FILE} COMMAND clang ${CLANG_ARG_LIST}
    DEPENDS ${INPUT_FILE} clang
    COMMENT "BUILDING bitcode for ${OUTPUT_FILE}..."
    VERBATIM)

if(${CMAKE_VERBOSE_MAKEFILE})
  message("      Kernel Source: " ${INPUT_FILE})
  message("     Kernel Bitcode: " ${OUTPUT_FILE})
endif()

endfunction(gen_kernel_bc)

##==========================================
## Find device code object name and forward to custom command
##==========================================
function(build_kernel BLIT_NAME TARGET_ID)

  string (REGEX MATCH "^gfx([^:]+)" GFXIP "${TARGET_ID}")
  # Report syntactically invalid target IDs and terminate.
  if (NOT GFXIP)
    message(FATAL_ERROR "Invalid target (${TARGET_ID}) specified for generating BLIT kerenel (${BLIT_NAME})")
    return()
  endif()

  ## generate kernel bitcodes
  set (CODE_OBJECT_FILE "${BLIT_NAME}_${GFXIP}")
  set (CL_FILE ${CMAKE_CURRENT_SOURCE_DIR}/imageblit_kernels.cl)
  gen_kernel_bc(${TARGET_ID} ${CL_FILE} ${CODE_OBJECT_FILE})

  ## Build a list of code object file names
  ## These will be target dependencies.
  set (HSACO_TARG_LIST ${HSACO_TARG_LIST} "${CODE_OBJECT_FILE}" PARENT_SCOPE)

endfunction(build_kernel)

##==========================================
## Build the kernel for a list of devices
##==========================================
function(build_kernel_for_devices BLIT_NAME)

  set(HSACO_TARG_LIST "")

  foreach(dev ${TARGET_DEVICES})
    if(${CMAKE_VERBOSE_MAKEFILE})
      message("\n  Generating: ${dev} ...")
    endif()
    build_kernel(${BLIT_NAME} ${dev})
  endforeach(dev)

  set(HSACO_TARG_LIST ${HSACO_TARG_LIST} PARENT_SCOPE)

endfunction(build_kernel_for_devices)

##==========================================
## Create BLIT Code Object blobs file
##==========================================
function(generate_blit_file BFILE)

  ## Add a custom command that generates opencl_blit_objects.cpp
  ## This depends on all the generated code object files and the C++ generator script.
  add_custom_command(OUTPUT ${BFILE}.cpp
                     COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/create_hsaco_ascii_file.sh ${CMAKE_CURRENT_BINARY_DIR}/${BFILE}.cpp
                     DEPENDS ${HSACO_TARG_LIST} create_hsaco_ascii_file.sh )

  ## Export a target that builds (and depends on) opencl_blit_objects.cpp
  add_custom_target( ${BFILE} DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${BFILE}.cpp )

endfunction(generate_blit_file)

build_kernel_for_devices("ocl_blit_object")
generate_blit_file("opencl_blit_objects")

=== debian/changelog ===
rocr-runtime (5.2.3-3) unstable; urgency=medium

  * Team upload.

  * add 0003-fix-static-initialization-order.patch
    to prevent crash in hsa_init (Closes: #1031089)
  * update d/copyright
  * d/control: update standards version

 -- Cordell Bloor <cgmb@slerp.xyz>  Sun, 19 Feb 2023 03:34:29 -0700

rocr-runtime (5.2.3-2) unstable; urgency=medium

  * 0002-remove-libhsa-amd-aqlprofile64.so-loading.patch: add;
    cancel noise caused by missing non-free library in build logs.
    Thanks to Cordell Bloor (Closes: #1024791)

 -- Étienne Mollier <emollier@debian.org>  Sat, 14 Jan 2023 11:49:05 +0100

rocr-runtime (5.2.3-1) unstable; urgency=medium

  * Migrate ROCm 5.2.3 to unstable.
  * d/control: bump build dependency on rocm-device-libs to >=5.2.
  * d/control: bump build dependencies to llvm 15.
  * d/control: adjust to new llvm packages layout.

 -- Étienne Mollier <emollier@debian.org>  Tue, 18 Oct 2022 19:16:28 +0200

rocr-runtime (5.2.3-1~0exp0) experimental; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.1 (routine-update)
  * Reorder sequence of d/control fields by cme (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields.  (routine-update)
  * d/control: add myself to uploaders.
  * d/control: bump versioned build-dependency libhsakmt-dev to 5.2.
  * d/libhsa-runtime*.install: update installation paths; libraries are now
    located in a multiarch friendly location.
  * d/copyright: remove redundant glob pattern.

 -- Étienne Mollier <emollier@debian.org>  Tue, 06 Sep 2022 21:58:59 +0200

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
ifneq (amd64,$(DEB_HOST_ARCH))
CMAKE_EXTRA_FLAGS:=-DIMAGE_SUPPORT=OFF
else
CMAKE_EXTRA_FLAGS:=
endif

%:
	dh $@ -Dsrc -Scmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBITCODE_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)/amdgcn/bitcode $(CMAKE_EXTRA_FLAGS)
# 		-DHSAKMT_INC_PATH=/usr/include/rocm
#		-DClang_DIR=/usr/lib/llvm13/

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%rocr-runtime-$1.tar.gz%" \
https://github.com/RadeonOpenCompute/ROCR-Runtime/tags \
(?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz debian

## rocr-runtime 5.7.1

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -59,8 +59,6 @@
 list ( APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake_modules" )
 include ( utils )
 include ( hsa_common )
-# Set default libdir to be "lib" for ROCm, distros will override this anyway:
-set(CMAKE_INSTALL_LIBDIR "lib" CACHE STRING "Library install directory")
 include ( GNUInstallDirs )
 
 ## Expose static library option
@@ -87,7 +85,7 @@
 endif() # if (ROCM_CCACHE_BUILD)
 
 ## Get version strings
-get_version ( "1.5.0" )
+get_version ( "1.11.0" )
 if ( ${ROCM_PATCH_VERSION} )
   set ( VERSION_PATCH ${ROCM_PATCH_VERSION})
 endif()
@@ -95,8 +93,10 @@
 set ( PACKAGE_VERSION_STRING "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_COMMIT_COUNT}" )
 
 ## Find external dependencies.
+find_package(PkgConfig)
 find_package(LibElf REQUIRED)
 find_package(hsakmt 1.0 REQUIRED HINTS ${CMAKE_INSTALL_PREFIX} PATHS /opt/rocm)
+pkg_check_modules(drm REQUIRED IMPORTED_TARGET libdrm)
 
 ## Create the rocr target.
 add_library( ${CORE_RUNTIME_TARGET} "" )
@@ -119,16 +119,20 @@
 target_include_directories( ${CORE_RUNTIME_TARGET}
   PUBLIC
   $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/inc>
-  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/hsa>
+  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
   PRIVATE
   ${CMAKE_CURRENT_SOURCE_DIR}
-  ${CMAKE_CURRENT_SOURCE_DIR}/libamdhsacode )
-
-## Set RUNPATH - ../../lib covers use of the legacy symlink in /hsa/lib/
-set_property(TARGET ${CORE_RUNTIME_TARGET} PROPERTY INSTALL_RPATH "$ORIGIN;$ORIGIN/../../lib;$ORIGIN/../../lib64;$ORIGIN/../lib64" )
+  ${CMAKE_CURRENT_SOURCE_DIR}/libamdhsacode
+  ${CMAKE_CURRENT_BINARY_DIR}/core/runtime/trap_handler)
+
 
 ## ------------------------- Linux Compiler and Linker options -------------------------
 set ( HSA_CXX_FLAGS ${HSA_COMMON_CXX_FLAGS} -fexceptions -fno-rtti -fvisibility=hidden -Wno-error=missing-braces -Wno-error=sign-compare -Wno-sign-compare -Wno-write-strings -Wno-conversion-null -fno-math-errno -fno-threadsafe-statics -fmerge-all-constants -fms-extensions -Wno-error=comment -Wno-comment -Wno-error=pointer-arith -Wno-pointer-arith -Wno-error=unused-variable -Wno-error=unused-function )
+
+## Extra x86 specific settings
+if ( CMAKE_SYSTEM_PROCESSOR MATCHES "i?86|x86_64|amd64|AMD64" )
+  set ( HSA_CXX_FLAGS ${HSA_CXX_FLAGS} -mmwaitx )
+endif()
 
 ## Extra image settings - audit!
 set ( HSA_CXX_FLAGS ${HSA_CXX_FLAGS} -Wno-deprecated-declarations )
@@ -182,6 +186,7 @@
            core/runtime/signal.cpp
            core/runtime/queue.cpp
            core/runtime/cache.cpp
+           core/runtime/svm_profiler.cpp
            core/common/shared.cpp
            core/common/hsa_table_interface.cpp
            loader/executable.cpp
@@ -192,6 +197,10 @@
            libamdhsacode/amd_hsa_code.cpp )
 
 target_sources( ${CORE_RUNTIME_TARGET} PRIVATE ${SRCS} )
+
+## Depend on trap handler target.
+add_subdirectory( ${CMAKE_CURRENT_SOURCE_DIR}/core/runtime/trap_handler )
+add_dependencies( ${CORE_RUNTIME_TARGET} amd_trap_handler_v2 )
 
 if ( NOT DEFINED IMAGE_SUPPORT AND CMAKE_SYSTEM_PROCESSOR MATCHES "i?86|x86_64|amd64|AMD64" )
   set ( IMAGE_SUPPORT ON )
@@ -220,6 +229,7 @@
                    image/addrlib/src/r800/siaddrlib.cpp
                    image/addrlib/src/gfx9/gfx9addrlib.cpp
                    image/addrlib/src/gfx10/gfx10addrlib.cpp
+                   image/addrlib/src/gfx11/gfx11addrlib.cpp
                    image/device_info.cpp
                    image/hsa_ext_image.cpp
                    image/image_runtime.cpp
@@ -227,7 +237,9 @@
                    image/image_manager_kv.cpp
                    image/image_manager_ai.cpp
                    image/image_manager_nv.cpp
+                   image/image_manager_gfx11.cpp
                    image/image_lut_kv.cpp
+                   image/image_lut_gfx11.cpp
                    image/blit_object_gfx7xx.cpp
                    image/blit_object_gfx8xx.cpp
                    image/blit_object_gfx9xx.cpp
@@ -246,9 +258,11 @@
     ${CMAKE_CURRENT_SOURCE_DIR}/image/addrlib/src/r800
     ${CMAKE_CURRENT_SOURCE_DIR}/image/addrlib/src/gfx9
     ${CMAKE_CURRENT_SOURCE_DIR}/image/addrlib/src/gfx10
+    ${CMAKE_CURRENT_SOURCE_DIR}/image/addrlib/src/gfx11
     ${CMAKE_CURRENT_SOURCE_DIR}/image/addrlib/src/chip/r800
     ${CMAKE_CURRENT_SOURCE_DIR}/image/addrlib/src/chip/gfx9
-    ${CMAKE_CURRENT_SOURCE_DIR}/image/addrlib/src/chip/gfx10 )
+    ${CMAKE_CURRENT_SOURCE_DIR}/image/addrlib/src/chip/gfx10
+    ${CMAKE_CURRENT_SOURCE_DIR}/image/addrlib/src/chip/gfx11 )
 
   target_sources( ${CORE_RUNTIME_TARGET} PRIVATE ${IMAGE_SRCS} )
 
@@ -259,13 +273,7 @@
 endif()
 
 ## Link dependencies.
-target_link_libraries ( ${CORE_RUNTIME_TARGET} PRIVATE hsakmt::hsakmt )
+target_link_libraries ( ${CORE_RUNTIME_TARGET} PRIVATE hsakmt::hsakmt PkgConfig::drm)
 target_link_libraries ( ${CORE_RUNTIME_TARGET} PRIVATE elf::elf dl pthread rt )
 
 ## Set the VERSION and SOVERSION values
-set_property ( TARGET ${CORE_RUNTIME_TARGET} PROPERTY VERSION "${SO_VERSION_STRING}" )
-set_property ( TARGET ${CORE_RUNTIME_TARGET} PROPERTY SOVERSION "${VERSION_MAJOR}" )
-
-## Add the public interface export target if doing a static build.
-## Bind ROCr dependencies to the interface target rather than to the source build
-## target so that -Wl,--whole-archive is tightly applied.  Requires binding

=== src/image/blit_src/CMakeLists.txt ===
--- 
+++ 
@@ -42,48 +42,14 @@
 
 cmake_minimum_required ( VERSION 3.7 )
 
-# Flag to abort before executing after default initialization of cache variables
-set (QUIT 0)
-
 # Import target 'clang'
-find_package(Clang REQUIRED HINTS ${CMAKE_INSTALL_PREFIX}/llvm ${CMAKE_PREFIX_PATH}/llvm PATHS /opt/rocm/llvm )
-
-# Device libs doesn't support find_package yet.
-set(PREFIX_HINTS "")
-foreach(hint "/amdgcn/bitcode" "/lib/bitcode" "/lib/x86_64/bitcode")
-  foreach(path ${CMAKE_PREFIX_PATH})
-    string(APPEND path ${hint})
-    list(APPEND PREFIX_HINTS ${path})
-  endforeach(path)
-endforeach(hint)
-
-get_include_path(BITCODE_DIR "Bitcode library path" RESULT FOUND NAMES "opencl.bc" "opencl.amdgcn.bc"
-  HINTS
-    "${CMAKE_INSTALL_PREFIX}/amdgcn/bitcode"
-    "${CMAKE_INSTALL_PREFIX}/lib/bitcode"
-    "${CMAKE_INSTALL_PREFIX}/lib/x86_64/bitcode"
-    "${PREFIX_HINTS}"
-  PATHS
-    "/opt/rocm/amdgcn/bitcode"
-    "/opt/rocm/lib/bitcode"
-    "/opt/rocm/lib"
-    "/opt/rocm/lib/x86_64/bitcode")
-if (NOT ${FOUND})
-  set (QUIT 1)
-endif()
+find_package(Clang REQUIRED HINTS ${CMAKE_PREFIX_PATH}/llvm PATHS /opt/rocm/llvm )
 
 # Determine the target devices if not specified
 if (NOT DEFINED TARGET_DEVICES)
-  set (TARGET_DEVICES "gfx700;gfx701;gfx702;gfx801;gfx802;gfx803;gfx805;gfx810;gfx900;gfx902;gfx904;gfx906;gfx908;gfx909;gfx90a;gfx90c;gfx1010;gfx1011;gfx1012;gfx1013;gfx1030;gfx1031;gfx1032;gfx1033;gfx1034;gfx1035")
+  set(TARGET_DEVICES "gfx700;gfx701;gfx702;gfx801;gfx802;gfx803;gfx805;gfx810;gfx900;gfx902;gfx904;gfx906;gfx908;gfx909;gfx90a;gfx90c;gfx940;gfx941;gfx942;gfx1010;gfx1011;gfx1012;gfx1013;gfx1030;gfx1031;gfx1032;gfx1033;gfx1034;gfx1035;gfx1036;gfx1100;gfx1101;gfx1102;gfx1103")
 endif()
 set( TARGET_DEVICES ${TARGET_DEVICES} CACHE STRING "Build targets" FORCE )
-
-# End of default configuration and path checking.
-# Quit if configuration is incomplete.
-if (QUIT)
-  message(FATAL_ERROR "Configuration halted.")
-  return()
-endif()
 
 if(${CMAKE_VERBOSE_MAKEFILE})
   get_property(clang_path TARGET clang PROPERTY LOCATION)
@@ -92,7 +58,6 @@
   message("  Target Devices*: ${TARGET_DEVICES}")
   message("  (Specify \";\" separated list of target IDs.)")
   message("       Clang path: ${clang_path}")
-  message("      Bitcode Dir: ${BITCODE_DIR}")
 endif()
 
 ##==========================================
@@ -100,36 +65,13 @@
 ##==========================================
 function(gen_kernel_bc TARGET_ID INPUT_FILE OUTPUT_FILE)
 
-  string (REGEX MATCH "^gfx([^:]+)" GFXIP "${TARGET_ID}")
-  set (GFXIP_NUMBER "${CMAKE_MATCH_1}")
-  # Report syntactically invalid target IDs and terminate.
-  if (NOT GFXIP)
-    message(FATAL_ERROR "Invalid target (${TARGET_ID}) specified for generating BLIT kerenel")
-    return()
-  endif()
-  # Determine if device-libs is following old or new layout
-  if(EXISTS "${BITCODE_DIR}/opencl.amdgcn.bc")
-    set(BITCODE_ARGS "-nogpulib
-      -Xclang -mlink-bitcode-file -Xclang ${BITCODE_DIR}/opencl.amdgcn.bc
-      -Xclang -mlink-bitcode-file -Xclang ${BITCODE_DIR}/ockl.amdgcn.bc
-      -Xclang -mlink-bitcode-file -Xclang ${BITCODE_DIR}/ocml.amdgcn.bc
-      -Xclang -mlink-bitcode-file -Xclang ${BITCODE_DIR}/oclc_daz_opt_on.amdgcn.bc
-      -Xclang -mlink-bitcode-file -Xclang ${BITCODE_DIR}/oclc_isa_version_${GFXIP_NUMBER}.amdgcn.bc
-      -Xclang -mlink-bitcode-file -Xclang ${BITCODE_DIR}/oclc_unsafe_math_off.amdgcn.bc
-      -Xclang -mlink-bitcode-file -Xclang ${BITCODE_DIR}/oclc_finite_only_off.amdgcn.bc")
-  else()
-    set(BITCODE_ARGS "--hip-device-lib-path=${BITCODE_DIR}")
-  endif()
-
   separate_arguments(CLANG_ARG_LIST UNIX_COMMAND
-    "-O2 -x cl -cl-denorms-are-zero -cl-std=CL2.0 -target amdgcn-amd-amdhsa
-    -Xclang -finclude-default-header -mcpu=${TARGET_ID}
-    ${BITCODE_ARGS} -o ${OUTPUT_FILE} ${INPUT_FILE}")
+    "-O2 -x cl -Xclang -finclude-default-header -cl-denorms-are-zero -cl-std=CL2.0
+    -target amdgcn-amd-amdhsa -mcpu=${TARGET_ID} -mcode-object-version=4
+    -o ${OUTPUT_FILE} ${INPUT_FILE}")
 
   ## Add custom command to produce a code object file.
   ## This depends on the kernel source file & compiler.
-  ## It does not pickup devicelib changes.  It is not clear
-  ## how to do that after conversion to --rocm-path is done.
   add_custom_command(OUTPUT ${OUTPUT_FILE} COMMAND clang ${CLANG_ARG_LIST}
     DEPENDS ${INPUT_FILE} clang
     COMMENT "BUILDING bitcode for ${OUTPUT_FILE}..."
@@ -147,15 +89,8 @@
 ##==========================================
 function(build_kernel BLIT_NAME TARGET_ID)
 
-  string (REGEX MATCH "^gfx([^:]+)" GFXIP "${TARGET_ID}")
-  # Report syntactically invalid target IDs and terminate.
-  if (NOT GFXIP)
-    message(FATAL_ERROR "Invalid target (${TARGET_ID}) specified for generating BLIT kerenel (${BLIT_NAME})")
-    return()
-  endif()
-
   ## generate kernel bitcodes
-  set (CODE_OBJECT_FILE "${BLIT_NAME}_${GFXIP}")
+  set (CODE_OBJECT_FILE "${BLIT_NAME}_${TARGET_ID}")
   set (CL_FILE ${CMAKE_CURRENT_SOURCE_DIR}/imageblit_kernels.cl)
   gen_kernel_bc(${TARGET_ID} ${CL_FILE} ${CODE_OBJECT_FILE})

=== debian/changelog ===
rocr-runtime (5.7.1-2build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:58:44 +1100

rocr-runtime (5.7.1-2) unstable; urgency=medium

  * Migrate to unstable.

 -- Cordell Bloor <cgmb@slerp.xyz>  Mon, 18 Mar 2024 18:46:07 -0600

rocr-runtime (5.7.1-2~exp1) experimental; urgency=medium

  * Add d/p/0003-expand-endian-detection.patch to fix arm64 and ppc64el
    endianness detection logic.
  * Add d/p/0006-initialize-chip-revision.patch to fix failing assertions
    on Rembrandt hardware.
  * Add d/gbp.conf to ensure use of pristine-tar.

 -- Cordell Bloor <cgmb@slerp.xyz>  Sun, 17 Mar 2024 23:51:29 -0600

rocr-runtime (5.7.1-1) unstable; urgency=medium

  * Migrate to unstable.
  * d/control: update B-D from pkg-config to pkgconf
  * d/p/0004-extend-isa-compatibility-check.patch: fix IsVersionCompatible
    results for gfx1012. The gfx1012 ISA is exactly equivalent to gfx1011.
  * Upstream version 5.7.1 includes hsa_amd_memory_async_copy_on_engine
    (Closes: #1022871).

 -- Cordell Bloor <cgmb@slerp.xyz>  Thu, 22 Feb 2024 21:19:35 -0700

rocr-runtime (5.7.1-1~exp2) experimental; urgency=medium

  * Add patch to link to drm_amdgpu to fix undefined symbols.
  * Fix missing paths in exported hsa-runtime64 CMake targets.
  * d/rules: cleanup unnecessary options

 -- Cordell Bloor <cgmb@slerp.xyz>  Tue, 09 Jan 2024 02:43:41 -0700

rocr-runtime (5.7.1-1~exp1) experimental; urgency=medium

  [ Cordell Bloor ]
  * New upstream version 5.7.1.
  * Update Build-Depends for clang-17.
  * Update upstream URL.

  [ Mo Zhou ]
  * Add the missing B-D pkg-config to fix FTBFS.
  * Upload to experimental.

 -- Cordell Bloor <cgmb@slerp.xyz>  Sun, 07 Jan 2024 18:13:42 -0700

rocr-runtime (5.2.3-6) unstable; urgency=medium

  * Add self to uploaders.
  * Add d/p/0005-disable-xnack-query-print.patch to disable message:
      KFD does not support xnack mode query.
      ROCr must assume xnack is disabled.
    (Closes: #1056170)

 -- Cordell Bloor <cgmb@slerp.xyz>  Fri, 24 Nov 2023 14:36:38 -0700

rocr-runtime (5.2.3-5) unstable; urgency=medium

  * Team upload.

  * d/p/0004-extend-isa-compatibility-check.patch: fix assertion when
    gfx906 falls back to gfx900.

 -- Cordell Bloor <cgmb@slerp.xyz>  Sat, 29 Jul 2023 15:41:52 -0600

rocr-runtime (5.2.3-4) unstable; urgency=medium

  [ Cordell Bloor ]
  * d/p/0004-extend-isa-compatibility-check.patch: cosmetic update.
    This is a superficial update to the variable naming for clarity. There
    are no functional changes to the program behaviour.

  [ Étienne Mollier ]
  * Migrate ISA compatibility improvements to unstable.
    Thanks to Cordell Bloor

 -- Étienne Mollier <emollier@debian.org>  Wed, 05 Jul 2023 20:57:23 +0200

rocr-runtime (5.2.3-4~exp1) experimental; urgency=medium

  * Team upload.

  * Improve ISA compatibility checks to enable loading gfx900, gfx1010 and
    gfx1030 kernels on other compatible hardware.
  * d/copyright: correct my email address

 -- Cordell Bloor <cgmb@slerp.xyz>  Thu, 25 May 2023 17:08:01 -0600

=== debian/control ===
Source: rocr-runtime
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>,
           Norbert Preining <norbert@preining.info>,
           Maxime Chambonnet <maxzor@maxzor.eu>,
           Étienne Mollier <emollier@debian.org>,
           Cordell Bloor <cgmb@slerp.xyz>
Section: video
Priority: optional
Build-Depends: clang-17,
               clang-tools-17,
               cmake,
               debhelper-compat (= 13),
               libclang-17-dev,
               libdrm-dev,
               libelf-dev,
               libhsakmt-dev (>= 5.7.0~),
               libmlir-17-dev,
               lld-17,
               llvm-17-dev,
               mlir-17-tools,
               rocm-device-libs-17,
               xxd,
               pkgconf,
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/rocm-team/rocr-runtime
Vcs-Git: https://salsa.debian.org/rocm-team/rocr-runtime.git
Homepage: https://github.com/ROCm/ROCR-Runtime/
Rules-Requires-Root: no

Package: libhsa-runtime64-1
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: HSA Runtime API and runtime for ROCm
 This library provides user-mode API interfaces necessary for host applications
 to launch compute kernels to available HSA ROCm kernel agents.

Package: libhsa-runtime-dev
Architecture: any
Section: libdevel
Depends: libhsa-runtime64-1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: HSA Runtime API and runtime for ROCm - development files
 This library provides user-mode API interfaces necessary for host applications
 to launch compute kernels to available HSA ROCm kernel agents.
 .
 This package contains the development headers.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
ifneq (amd64,$(DEB_HOST_ARCH))
CMAKE_EXTRA_FLAGS:=-DIMAGE_SUPPORT=OFF
else
CMAKE_EXTRA_FLAGS:=
endif

CMAKE_EXTRA_FLAGS += \
 -DINCLUDE_PATH_COMPATIBILITY=OFF

%:
	dh $@ -Dsrc -Scmake

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%rocr-runtime-$1.tar.gz%" \
https://github.com/ROCm/ROCR-Runtime/tags \
(?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz debian
